## 1.运行代码
```shell
source /your_path/devel/setup.bash
roslaunch lstrobot_planning set_update_paramter_p.launch
```  

## 2.package(SRC)
1. **lstrobot_planning**  
1.1 **launch**-launch启动文件  
1.2 **msg**-自定义消息  
1.3 **scripts**-Python代码

2. **mr12urdf20240605**  
2.1 **config**-机械臂先关配置文件  
2.2 **launch**-launch启动文件  
2.3 **meshes**-机械臂STL文件  
2.4 **urdf**-机械臂urdf模型  

3. **lstrobot_moveit_config_0605**  
3.1 **config**-moveit配置文件，常用srdf(修改机器人配置)  
3.2 **launch**-launch启动文件，包括demo.launch文件 

4. **Data**  
4.1 点云数据，起始点终点数据，导出的其他的数据(轨迹关节值、末端执行器笛卡尔坐标) 

5. **visual**  
5.1 规划结果可视化  
5.2 该功能包需要安装moveit_visual_tools依赖包  
5.3 可能需要手动订阅/rviz_visual_tools主题  

## 2024.07.31
- 做了关节限位，规划时不会出现大角度差姿态来回切换
- 对move_p做了轨迹间路径约束，移动时末端执行器不会走冗余路径

## 2024.08.05
- 修改rvizload，通过py程序调起rviz
- 增加rviz启动等待功能
- 增加close_rviz函数，通过py接口关闭程序时顺带关闭rviz
- 增加ROS转py成员变量接口  包括：
	{
		焊接轨迹点坐标
		焊接轨迹点隶属类型
		焊接序号列表
		焊接轨迹规划失败序号列表
	}
- 增加 不重新加载点云和焊接顺序姿态只重新规划机器人路径和运动学逆解的接口
- 因为是多文件启动 修改程序逻辑防止规划器被2次启动

## 2024.08.07
- 取消了焊缝剔除 通过延长焊丝坐标系的方式防碰撞（同时修改urdf和config 的end_effector_link）
- 增加了轨迹可视化节点(visual 注意：该功能需要安装moveit_visual_tools依赖包)

## 2024.09.01
- 修复从起点规划到第一个失败后的重新设定约束逻辑问题

## 2024.09.02
- 通过限制6轴自由度解决六轴翻转问题

## 2024.09.03
- 增加 自定义设置路径速度因子v和加速度因子a的接口

## 2024.09.10
- 优化 增加焊缝规划失败处理逻辑，如果焊缝起点不可达，则直接跳过本条焊缝，并进行失败标记

## 2024.09.18
- 优化 使用check来检查第六轴翻转，不再限制第六轴关节角度

## 2024.11.06
- 优化 修改demo.lanuch的启动方式为后台静默启动

## 2024.11.16
- 修复 修复因使用进程进行后台静默启动导致的缓冲区溢出问题(导致程序卡死)；目前解决办法为将
  输出直接丢弃或是重定向到log文件
- 修改 将点云的加载方式改为从ROS参数服务器获取对应控制参数


